#include "vec.h"

/* **************************************************************************
   **************** Vec3_32 (32bit int) ****************************************
   ************************************************************************** */

#define _V_NEW_M_(TYPE) {\
  TYPE * self = s_malloc (sizeof (TYPE));\
  self->a = a;\
  self->b = b;\
  self->c = c;\
  return self;\
}

#define _V_ADD_M_(TYPE) {\
  TYPE * new_v = s_malloc (sizeof (TYPE));\
  new_v->a = a->a + b->a;\
  new_v->b = a->b + b->b;\
  new_v->c = a->c + b->c;\
  return new_v;\
}

Vec3_32 *
vec3_32_new (sint a,
          sint b,
          sint c) {
  _V_NEW_M_(Vec3_32);
}

Vec3_32 *
vec3_32_add_Vec3_32 (Vec3_32 * a,
               Vec3_32 * b) {
  _V_ADD_M_(Vec3_32);
}

Vec3_32 *
vec3_32_add_vec3_16 (Vec3_32 * a,
                  Vec3_16 * b) {
  _V_ADD_M_(Vec3_32);
}

Vec3_32 *
vec3_16_add_Vec3_32 (Vec3_16 * a,
                  Vec3_32 * b) {
  _V_ADD_M_(Vec3_32);
}

/* **************************************************************************
   **************** VEC3_16 (16bit int) *************************************
   ************************************************************************** */

Vec3_16 *
vec3_16_new (sshort a,
             sshort b,
             sshort c) {
  _V_NEW_M_(Vec3_16);
}

Vec3_16 *
vec3_16_add_vec3_16 (Vec3_16 * a,
                     Vec3_16 * b) {
  _V_ADD_M_(Vec3_16);
}


/* **************************************************************************
   **************** VEC3_f (Float) ******************************************
   ************************************************************************** */

Vec3_f *
vec3_f_new (sfloat a,
            sfloat b,
            sfloat c) {
  _V_NEW_M_(Vec3_f);
}

Vec3_f *
vec3_f_add_vec3_f (Vec3_f * a,
                   Vec3_f * b) {
  _V_ADD_M_(Vec3_f);
}

Vec3_f *
vec3_f_add_Vec3_32 (Vec3_f * a,
                 Vec3_32 * b) {
  _V_ADD_M_(Vec3_f);
}

Vec3_f *
vec3_f_add_vec3_16 (Vec3_f * a,
                    Vec3_16 * b) {
  _V_ADD_M_(Vec3_f);
}

Vec3_f *
vec3_add_vec3_f (Vec3_32 * a,
                Vec3_f * b) {
  _V_ADD_M_(Vec3_f);
}

Vec3_f *
vec3_16_add_vec3_f (Vec3_16 * a,
                   Vec3_f * b) {
  _V_ADD_M_(Vec3_f);
}

